<?php

if (!defined('WPINC')) {
    die;
}
if (!class_exists('Delyva_Shipping_API')) {
    class Delyva_Shipping_API
    {
        private static $api_endpoint = "https://api.matdespatch.my";
        public static function getShippingRate($destination, $items)
        {
            $settings = get_option( 'woocommerce_delyva_settings' );
            $url = Self::$api_endpoint . "/api/integration/woocommerce/getRates/" . trim(esc_attr($settings['integration_id']), " ");
            $requestArr = [
                'destination' => $destination,
                'items' => $items,
            ];

            $response = wp_remote_post($url, array(
                'headers' => array('content-type' => 'application/json'),
                'body' => json_encode($requestArr),
                'method' => 'POST',
                'timeout' => 25
            ));

            if (is_wp_error($response)) {
                $error_message = $response->get_error_message();
                if ($error_message == 'fsocket timed out') {
                    throw new Exception("Sorry, the shipping rates are currently unavailable, please refresh the page or try again later");
                } else {
                    throw new Exception("Sorry, something went wrong with the shipping rates. If the problem persists, please contact us!");
                }
            } else {
                if ($response['response']['code'] == 200) {
                    $body = json_decode($response['body'], true);
                    return $body['rates'];
                } else {
                    throw new Exception("Sorry, something went wrong with the shipping rates. If the problem persists, please contact us!");
                }
            }
        }
    }
}
